# !/usr/bin/perl -w
#	
#This program is used for parallel computation of ESPRIT
# 
# Last Modified: SEP 26, 2012
###########################################################################
# usage: perl MT_esprit_needle.pl -s ../test/test.fas -n 10
#	Parameters:
#		-s .fas raw sequence input file
#		-n number of theads (n*(n+1)/2)
# 
#
###########################################################################

use strict;
use warnings;
use diagnostics;
use threads;


my $size = scalar @ARGV;
my $allRequired = 2;

my ($inputSeqName,$num);

for(my $a = 0; $a < $size; $a++)
{
	if($ARGV[$a] eq "-s")
	{
		$a++;
		$allRequired--;
		$inputSeqName = $ARGV[$a];
	}
	elsif($ARGV[$a] eq "-n")
	{
		$a++;
		$allRequired--;
		$num = $ARGV[$a];
	}	
}

if($allRequired != 0)
{
	print "Please make sure you entered all of the required parameters.\n";
	exit;
}

my $ind=rindex($inputSeqName,"\.");
my $pre=substr($inputSeqName,0,$ind);
my @thr=();

my $count=0;
for (my $i=1; $i<=$num; $i++)
{
	for (my $j=$i; $j<=$num; $j++)
	{
		$thr[$count]=threads->create('formdistance_Needle',$i,$j);
		$count++;
	}
}


for (my $i=0; $i<$count; $i++)
{
	$thr[$i]->join();
}

my $cmd="cat ";
for (my $i=1; $i<=$num; $i++)
{
	for (my $j=$i; $j<=$num; $j++)
	{
		$cmd=$cmd.$pre.".ndist_$i"."_$j ";
	}
}
$cmd=$cmd.">"."$pre".".ndist";
system($cmd);


sub formdistance_Needle { #input: id1, id2, id3
	my ($id1,$id2)=@_;
	my $cmd;
	$cmd="./kmerdist_par -u 0.8 ".$inputSeqName." $num $id1 $id2";
	#print "$cmd\n";
	system($cmd);
	$cmd="./needledist "."$inputSeqName ".$pre."_$id1"."_$id2".".dist ".$pre.".ndist_".$id1."_$id2";
	#print "$cmd\n";
	system($cmd);
}
	
		